import numpy as np
import logging
def get_mask_any(shape_mask, _u, _d, _l, _r):
    _mask = np.zeros(shape_mask, dtype='float32')
    _mask[_u:_d, _l:_r] = 1.0
    return _mask
def get_center_mask(shape_mask, _sz): # mask center a _sz x _sz patch
    _u = int((shape_mask[0] - _sz) / 2)
    _d = _u + _sz
    _l = int((shape_mask[1] - _sz) / 2)
    _r = _l + _sz
    return get_mask_any(shape_mask, _u, _d, _l, _r)
def get_center_mask_axis(shape_mask, _sz, _axis, l_lim_max=999999, r_lim_min=0): # mask center a _sz x _sz patch, axis=0 mean H is full, axis=1 mean W is full, 
    _u = int((shape_mask[0] - _sz) / 2)
    _d = _u + _sz
    _l = int((shape_mask[1] - _sz) / 2)
    _r = _l + _sz

    _ul = [_u, _l]
    _ul[_axis] = 0
    _ul[1-_axis] = min(_ul[1-_axis], l_lim_max)
    _u, _l = _ul

    _dr = [_d, _r]
    _dr[_axis] = shape_mask[_axis]
    _dr[1-_axis] = max(_dr[1-_axis], r_lim_min)
    _d, _r = _dr

    logging.info('u, d, l, r = {}'.format([_u, _d, _l, _r]))
    return get_mask_any(shape_mask, _u, _d, _l, _r)